/* rygel-music-item.c generated by valac 0.56.3, the Vala compiler
 * generated from rygel-music-item.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Doug Galligan <doug@sentosatech.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-server.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libgupnp-av/gupnp-av.h>
#include <glib-object.h>
#include "rygel-core.h"
#include <libgupnp/gupnp.h>
#include <libgssdp/gssdp.h>
#include <gio/gio.h>

enum  {
	RYGEL_MUSIC_ITEM_0_PROPERTY,
	RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY,
	RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY,
	RYGEL_MUSIC_ITEM_NUM_PROPERTIES
};
static GParamSpec* rygel_music_item_properties[RYGEL_MUSIC_ITEM_NUM_PROPERTIES];
#define _rygel_icon_info_unref0(var) ((var == NULL) ? NULL : (var = (rygel_icon_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelMusicItemPrivate {
	gint _track_number;
	RygelThumbnail* _album_art;
};

static gint RygelMusicItem_private_offset;
static gpointer rygel_music_item_parent_class = NULL;

VALA_EXTERN gint rygel_media_object_compare_by_property (RygelMediaObject* self,
                                             RygelMediaObject* media_object,
                                             const gchar* property);
VALA_EXTERN void rygel_media_object_apply_didl_lite (RygelMediaObject* self,
                                         GUPnPDIDLLiteObject* didl_object);
static gint rygel_music_item_real_compare_by_property (RygelMediaObject* base,
                                                RygelMediaObject* media_object,
                                                const gchar* property);
static void rygel_music_item_real_apply_didl_lite (RygelMediaObject* base,
                                            GUPnPDIDLLiteObject* didl_object);
static GUPnPDIDLLiteObject* rygel_music_item_real_serialize (RygelMediaObject* base,
                                                      RygelSerializer* serializer,
                                                      RygelHTTPServer* http_server,
                                                      GError** error);
VALA_EXTERN gchar* rygel_media_object_get_protocol_for_uri (RygelMediaObject* self,
                                                const gchar* uri,
                                                GError** error);
VALA_EXTERN gchar* rygel_http_server_create_uri_for_object (RygelHTTPServer* self,
                                                RygelMediaObject* object,
                                                gint thumbnail_index,
                                                gint subtitle_index,
                                                const gchar* resource_name);
static void rygel_music_item_finalize (GObject * obj);
static GType rygel_music_item_get_type_once (void);
static void _vala_rygel_music_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_rygel_music_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
rygel_music_item_get_instance_private (RygelMusicItem* self)
{
	return G_STRUCT_MEMBER_P (self, RygelMusicItem_private_offset);
}

RygelMusicItem*
rygel_music_item_construct (GType object_type,
                            const gchar* id,
                            RygelMediaContainer* parent,
                            const gchar* title,
                            const gchar* upnp_class)
{
	RygelMusicItem * self = NULL;
#line 42 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 42 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 42 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 42 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (upnp_class != NULL, NULL);
#line 46 "../src/librygel-server/rygel-music-item.vala"
	self = (RygelMusicItem*) g_object_new (object_type, "id", id, "parent", parent, "title", title, "upnp-class", upnp_class, NULL);
#line 42 "../src/librygel-server/rygel-music-item.vala"
	return self;
#line 124 "rygel-music-item.c"
}

RygelMusicItem*
rygel_music_item_new (const gchar* id,
                      RygelMediaContainer* parent,
                      const gchar* title,
                      const gchar* upnp_class)
{
#line 42 "../src/librygel-server/rygel-music-item.vala"
	return rygel_music_item_construct (RYGEL_TYPE_MUSIC_ITEM, id, parent, title, upnp_class);
#line 135 "rygel-music-item.c"
}

void
rygel_music_item_lookup_album_art (RygelMusicItem* self)
{
	RygelThumbnail* _tmp0_;
	RygelMediaArtStore* media_art_store = NULL;
	RygelMediaArtStore* _tmp1_;
	RygelMediaArtStore* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 52 "../src/librygel-server/rygel-music-item.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/librygel-server/rygel-music-item.vala"
	_tmp0_ = self->priv->_album_art;
#line 53 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp0_ != NULL) {
#line 54 "../src/librygel-server/rygel-music-item.vala"
		return;
#line 154 "rygel-music-item.c"
	}
#line 57 "../src/librygel-server/rygel-music-item.vala"
	_tmp1_ = rygel_media_art_store_get_default ();
#line 57 "../src/librygel-server/rygel-music-item.vala"
	media_art_store = _tmp1_;
#line 58 "../src/librygel-server/rygel-music-item.vala"
	_tmp2_ = media_art_store;
#line 58 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp2_ == NULL) {
#line 59 "../src/librygel-server/rygel-music-item.vala"
		_g_object_unref0 (media_art_store);
#line 59 "../src/librygel-server/rygel-music-item.vala"
		return;
#line 168 "rygel-music-item.c"
	}
	{
		RygelThumbnail* _tmp3_ = NULL;
		RygelMediaArtStore* _tmp4_;
		RygelThumbnail* _tmp5_;
#line 63 "../src/librygel-server/rygel-music-item.vala"
		_tmp4_ = media_art_store;
#line 63 "../src/librygel-server/rygel-music-item.vala"
		_tmp5_ = rygel_media_art_store_lookup_media_art (_tmp4_, self, &_inner_error0_);
#line 63 "../src/librygel-server/rygel-music-item.vala"
		_tmp3_ = _tmp5_;
#line 63 "../src/librygel-server/rygel-music-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "rygel-music-item.c"
			goto __catch0_g_error;
		}
#line 63 "../src/librygel-server/rygel-music-item.vala"
		rygel_music_item_set_album_art (self, _tmp3_);
#line 62 "../src/librygel-server/rygel-music-item.vala"
		_rygel_icon_info_unref0 (_tmp3_);
#line 189 "rygel-music-item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 62 "../src/librygel-server/rygel-music-item.vala"
		_error_ = _inner_error0_;
#line 62 "../src/librygel-server/rygel-music-item.vala"
		_inner_error0_ = NULL;
#line 65 "../src/librygel-server/rygel-music-item.vala"
		_tmp6_ = _error_;
#line 65 "../src/librygel-server/rygel-music-item.vala"
		_tmp7_ = _tmp6_->message;
#line 65 "../src/librygel-server/rygel-music-item.vala"
		g_debug ("rygel-music-item.vala:65: Failed to look up album art: %s", _tmp7_);
#line 62 "../src/librygel-server/rygel-music-item.vala"
		_g_error_free0 (_error_);
#line 209 "rygel-music-item.c"
	}
	__finally0:
#line 62 "../src/librygel-server/rygel-music-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/librygel-server/rygel-music-item.vala"
		_g_object_unref0 (media_art_store);
#line 62 "../src/librygel-server/rygel-music-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/librygel-server/rygel-music-item.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../src/librygel-server/rygel-music-item.vala"
		return;
#line 222 "rygel-music-item.c"
	}
#line 52 "../src/librygel-server/rygel-music-item.vala"
	_g_object_unref0 (media_art_store);
#line 226 "rygel-music-item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/librygel-server/rygel-music-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 234 "rygel-music-item.c"
}

static gint
rygel_music_item_real_compare_by_property (RygelMediaObject* base,
                                           RygelMediaObject* media_object,
                                           const gchar* property)
{
	RygelMusicItem * self;
	RygelMusicItem* item = NULL;
	RygelMusicItem* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 77 "../src/librygel-server/rygel-music-item.vala"
	static GQuark _tmp2_label0 = 0;
#line 249 "rygel-music-item.c"
	gint result;
#line 69 "../src/librygel-server/rygel-music-item.vala"
	self = (RygelMusicItem*) base;
#line 69 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (media_object != NULL, 0);
#line 69 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (property != NULL, 0);
#line 71 "../src/librygel-server/rygel-music-item.vala"
	if (!RYGEL_IS_MUSIC_ITEM (media_object)) {
#line 72 "../src/librygel-server/rygel-music-item.vala"
		result = 1;
#line 72 "../src/librygel-server/rygel-music-item.vala"
		return result;
#line 263 "rygel-music-item.c"
	}
#line 75 "../src/librygel-server/rygel-music-item.vala"
	_tmp0_ = _g_object_ref0 (RYGEL_IS_MUSIC_ITEM (media_object) ? ((RygelMusicItem*) media_object) : NULL);
#line 75 "../src/librygel-server/rygel-music-item.vala"
	item = _tmp0_;
#line 77 "../src/librygel-server/rygel-music-item.vala"
	_tmp1_ = property;
#line 77 "../src/librygel-server/rygel-music-item.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 77 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("upnp:originalTrackNumber")))) {
#line 77 "../src/librygel-server/rygel-music-item.vala"
		switch (0) {
#line 277 "rygel-music-item.c"
			default:
			{
				gint _tmp4_;
				RygelMusicItem* _tmp5_;
				gint _tmp6_;
#line 79 "../src/librygel-server/rygel-music-item.vala"
				_tmp4_ = self->priv->_track_number;
#line 79 "../src/librygel-server/rygel-music-item.vala"
				_tmp5_ = item;
#line 79 "../src/librygel-server/rygel-music-item.vala"
				_tmp6_ = _tmp5_->priv->_track_number;
#line 79 "../src/librygel-server/rygel-music-item.vala"
				result = rygel_media_object_compare_int_props ((RygelMediaObject*) self, _tmp4_, _tmp6_);
#line 79 "../src/librygel-server/rygel-music-item.vala"
				_g_object_unref0 (item);
#line 79 "../src/librygel-server/rygel-music-item.vala"
				return result;
#line 295 "rygel-music-item.c"
			}
		}
	} else {
#line 77 "../src/librygel-server/rygel-music-item.vala"
		switch (0) {
#line 301 "rygel-music-item.c"
			default:
			{
				RygelMusicItem* _tmp7_;
#line 82 "../src/librygel-server/rygel-music-item.vala"
				_tmp7_ = item;
#line 82 "../src/librygel-server/rygel-music-item.vala"
				result = RYGEL_MEDIA_OBJECT_CLASS (rygel_music_item_parent_class)->compare_by_property ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), (RygelMediaObject*) _tmp7_, property);
#line 82 "../src/librygel-server/rygel-music-item.vala"
				_g_object_unref0 (item);
#line 82 "../src/librygel-server/rygel-music-item.vala"
				return result;
#line 313 "rygel-music-item.c"
			}
		}
	}
}

static void
rygel_music_item_real_apply_didl_lite (RygelMediaObject* base,
                                       GUPnPDIDLLiteObject* didl_object)
{
	RygelMusicItem * self;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 86 "../src/librygel-server/rygel-music-item.vala"
	self = (RygelMusicItem*) base;
#line 86 "../src/librygel-server/rygel-music-item.vala"
	g_return_if_fail (didl_object != NULL);
#line 87 "../src/librygel-server/rygel-music-item.vala"
	RYGEL_MEDIA_OBJECT_CLASS (rygel_music_item_parent_class)->apply_didl_lite ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), didl_object);
#line 89 "../src/librygel-server/rygel-music-item.vala"
	_tmp0_ = gupnp_didl_lite_object_get_track_number (didl_object);
#line 89 "../src/librygel-server/rygel-music-item.vala"
	_tmp1_ = _tmp0_;
#line 89 "../src/librygel-server/rygel-music-item.vala"
	rygel_music_item_set_track_number (self, _tmp1_);
#line 91 "../src/librygel-server/rygel-music-item.vala"
	_tmp3_ = gupnp_didl_lite_object_get_album_art (didl_object);
#line 91 "../src/librygel-server/rygel-music-item.vala"
	_tmp4_ = _tmp3_;
#line 91 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp4_ != NULL) {
#line 347 "rygel-music-item.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp5_ = gupnp_didl_lite_object_get_album_art (didl_object);
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp6_ = _tmp5_;
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp7_ = strlen (_tmp6_);
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp8_ = _tmp7_;
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp2_ = _tmp8_ > 0;
#line 362 "rygel-music-item.c"
	} else {
#line 91 "../src/librygel-server/rygel-music-item.vala"
		_tmp2_ = FALSE;
#line 366 "rygel-music-item.c"
	}
#line 91 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp2_) {
#line 370 "rygel-music-item.c"
		RygelThumbnail* _tmp9_;
		RygelThumbnail* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 92 "../src/librygel-server/rygel-music-item.vala"
		_tmp9_ = self->priv->_album_art;
#line 92 "../src/librygel-server/rygel-music-item.vala"
		if (_tmp9_ == NULL) {
#line 380 "rygel-music-item.c"
			RygelThumbnail* _tmp10_;
			RygelThumbnail* _tmp11_;
#line 93 "../src/librygel-server/rygel-music-item.vala"
			_tmp10_ = rygel_thumbnail_new ("image/jpeg", "JPEG_TN", "jpg");
#line 93 "../src/librygel-server/rygel-music-item.vala"
			_tmp11_ = _tmp10_;
#line 93 "../src/librygel-server/rygel-music-item.vala"
			rygel_music_item_set_album_art (self, _tmp11_);
#line 93 "../src/librygel-server/rygel-music-item.vala"
			_rygel_icon_info_unref0 (_tmp11_);
#line 391 "rygel-music-item.c"
		}
#line 94 "../src/librygel-server/rygel-music-item.vala"
		_tmp12_ = self->priv->_album_art;
#line 94 "../src/librygel-server/rygel-music-item.vala"
		_tmp13_ = gupnp_didl_lite_object_get_album_art (didl_object);
#line 94 "../src/librygel-server/rygel-music-item.vala"
		_tmp14_ = _tmp13_;
#line 94 "../src/librygel-server/rygel-music-item.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 94 "../src/librygel-server/rygel-music-item.vala"
		_g_free0 (((RygelIconInfo*) _tmp12_)->uri);
#line 94 "../src/librygel-server/rygel-music-item.vala"
		((RygelIconInfo*) _tmp12_)->uri = _tmp15_;
#line 405 "rygel-music-item.c"
	} else {
		RygelThumbnail* _tmp16_;
#line 95 "../src/librygel-server/rygel-music-item.vala"
		_tmp16_ = self->priv->_album_art;
#line 95 "../src/librygel-server/rygel-music-item.vala"
		if (_tmp16_ != NULL) {
#line 96 "../src/librygel-server/rygel-music-item.vala"
			rygel_music_item_set_album_art (self, NULL);
#line 414 "rygel-music-item.c"
		}
	}
}

static GUPnPDIDLLiteObject*
rygel_music_item_real_serialize (RygelMediaObject* base,
                                 RygelSerializer* serializer,
                                 RygelHTTPServer* http_server,
                                 GError** error)
{
	RygelMusicItem * self;
	GUPnPDIDLLiteObject* didl_item = NULL;
	GUPnPDIDLLiteObject* _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
	GUPnPDIDLLiteObject* result;
#line 99 "../src/librygel-server/rygel-music-item.vala"
	self = (RygelMusicItem*) base;
#line 99 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (serializer != NULL, NULL);
#line 99 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (http_server != NULL, NULL);
#line 102 "../src/librygel-server/rygel-music-item.vala"
	_tmp0_ = RYGEL_MEDIA_OBJECT_CLASS (rygel_music_item_parent_class)->serialize ((RygelMediaObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_AUDIO_ITEM, RygelAudioItem), serializer, http_server, &_inner_error0_);
#line 102 "../src/librygel-server/rygel-music-item.vala"
	didl_item = _tmp0_;
#line 102 "../src/librygel-server/rygel-music-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../src/librygel-server/rygel-music-item.vala"
		g_propagate_error (error, _inner_error0_);
#line 102 "../src/librygel-server/rygel-music-item.vala"
		return NULL;
#line 450 "rygel-music-item.c"
	}
#line 104 "../src/librygel-server/rygel-music-item.vala"
	_tmp1_ = self->priv->_track_number;
#line 104 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp1_ >= 0) {
#line 456 "rygel-music-item.c"
		GUPnPDIDLLiteObject* _tmp2_;
		gint _tmp3_;
#line 105 "../src/librygel-server/rygel-music-item.vala"
		_tmp2_ = didl_item;
#line 105 "../src/librygel-server/rygel-music-item.vala"
		_tmp3_ = self->priv->_track_number;
#line 105 "../src/librygel-server/rygel-music-item.vala"
		gupnp_didl_lite_object_set_track_number (_tmp2_, _tmp3_);
#line 465 "rygel-music-item.c"
	}
#line 108 "../src/librygel-server/rygel-music-item.vala"
	_tmp5_ = rygel_media_file_item_get_place_holder ((RygelMediaFileItem*) self);
#line 108 "../src/librygel-server/rygel-music-item.vala"
	_tmp6_ = _tmp5_;
#line 108 "../src/librygel-server/rygel-music-item.vala"
	if (!_tmp6_) {
#line 473 "rygel-music-item.c"
		RygelThumbnail* _tmp7_;
#line 108 "../src/librygel-server/rygel-music-item.vala"
		_tmp7_ = self->priv->_album_art;
#line 108 "../src/librygel-server/rygel-music-item.vala"
		_tmp4_ = _tmp7_ != NULL;
#line 479 "rygel-music-item.c"
	} else {
#line 108 "../src/librygel-server/rygel-music-item.vala"
		_tmp4_ = FALSE;
#line 483 "rygel-music-item.c"
	}
#line 108 "../src/librygel-server/rygel-music-item.vala"
	if (_tmp4_) {
#line 487 "rygel-music-item.c"
		gchar* protocol = NULL;
		RygelThumbnail* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 109 "../src/librygel-server/rygel-music-item.vala"
		_tmp8_ = self->priv->_album_art;
#line 109 "../src/librygel-server/rygel-music-item.vala"
		_tmp9_ = ((RygelIconInfo*) _tmp8_)->uri;
#line 109 "../src/librygel-server/rygel-music-item.vala"
		_tmp10_ = rygel_media_object_get_protocol_for_uri ((RygelMediaObject*) self, _tmp9_, &_inner_error0_);
#line 109 "../src/librygel-server/rygel-music-item.vala"
		protocol = _tmp10_;
#line 109 "../src/librygel-server/rygel-music-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/librygel-server/rygel-music-item.vala"
			g_propagate_error (error, _inner_error0_);
#line 109 "../src/librygel-server/rygel-music-item.vala"
			_g_object_unref0 (didl_item);
#line 109 "../src/librygel-server/rygel-music-item.vala"
			return NULL;
#line 509 "rygel-music-item.c"
		}
#line 113 "../src/librygel-server/rygel-music-item.vala"
		if (rygel_http_server_is_local (http_server)) {
#line 113 "../src/librygel-server/rygel-music-item.vala"
			_tmp11_ = TRUE;
#line 515 "rygel-music-item.c"
		} else {
			const gchar* _tmp12_;
#line 113 "../src/librygel-server/rygel-music-item.vala"
			_tmp12_ = protocol;
#line 113 "../src/librygel-server/rygel-music-item.vala"
			_tmp11_ = g_strcmp0 (_tmp12_, "internal") != 0;
#line 522 "rygel-music-item.c"
		}
#line 113 "../src/librygel-server/rygel-music-item.vala"
		if (_tmp11_) {
#line 526 "rygel-music-item.c"
			GUPnPDIDLLiteObject* _tmp13_;
			RygelThumbnail* _tmp14_;
			const gchar* _tmp15_;
#line 114 "../src/librygel-server/rygel-music-item.vala"
			_tmp13_ = didl_item;
#line 114 "../src/librygel-server/rygel-music-item.vala"
			_tmp14_ = self->priv->_album_art;
#line 114 "../src/librygel-server/rygel-music-item.vala"
			_tmp15_ = ((RygelIconInfo*) _tmp14_)->uri;
#line 114 "../src/librygel-server/rygel-music-item.vala"
			gupnp_didl_lite_object_set_album_art (_tmp13_, _tmp15_);
#line 538 "rygel-music-item.c"
		} else {
			gchar* http_uri = NULL;
			gchar* _tmp16_;
			gchar* _tmp17_ = NULL;
			GRegex* _tmp18_;
			const gchar* _tmp19_;
			GUPnPContext* _tmp20_;
			GInetAddress* _tmp21_;
			GInetAddress* _tmp22_;
			GInetAddress* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			GUPnPDIDLLiteObject* _tmp28_;
#line 117 "../src/librygel-server/rygel-music-item.vala"
			_tmp16_ = rygel_http_server_create_uri_for_object (http_server, (RygelMediaObject*) self, 0, -1, NULL);
#line 117 "../src/librygel-server/rygel-music-item.vala"
			http_uri = _tmp16_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp18_ = rygel_media_file_item_address_regex;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp19_ = http_uri;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp20_ = http_server->context;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp21_ = gssdp_client_get_address ((GSSDPClient*) _tmp20_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp22_ = _tmp21_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp23_ = _tmp22_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp24_ = g_inet_address_to_string (_tmp23_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp25_ = _tmp24_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp26_ = g_regex_replace_literal (_tmp18_, _tmp19_, (gssize) -1, 0, _tmp25_, 0, &_inner_error0_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp27_ = _tmp26_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_g_free0 (_tmp25_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_g_object_unref0 (_tmp23_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp17_ = _tmp27_;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/librygel-server/rygel-music-item.vala"
				g_propagate_error (error, _inner_error0_);
#line 121 "../src/librygel-server/rygel-music-item.vala"
				_g_free0 (http_uri);
#line 121 "../src/librygel-server/rygel-music-item.vala"
				_g_free0 (protocol);
#line 121 "../src/librygel-server/rygel-music-item.vala"
				_g_object_unref0 (didl_item);
#line 121 "../src/librygel-server/rygel-music-item.vala"
				return NULL;
#line 596 "rygel-music-item.c"
			}
#line 121 "../src/librygel-server/rygel-music-item.vala"
			_tmp28_ = didl_item;
#line 121 "../src/librygel-server/rygel-music-item.vala"
			gupnp_didl_lite_object_set_album_art (_tmp28_, _tmp17_);
#line 113 "../src/librygel-server/rygel-music-item.vala"
			_g_free0 (_tmp17_);
#line 113 "../src/librygel-server/rygel-music-item.vala"
			_g_free0 (http_uri);
#line 606 "rygel-music-item.c"
		}
#line 108 "../src/librygel-server/rygel-music-item.vala"
		_g_free0 (protocol);
#line 610 "rygel-music-item.c"
	}
#line 129 "../src/librygel-server/rygel-music-item.vala"
	result = didl_item;
#line 129 "../src/librygel-server/rygel-music-item.vala"
	return result;
#line 616 "rygel-music-item.c"
}

gint
rygel_music_item_get_track_number (RygelMusicItem* self)
{
	gint result;
#line 38 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/librygel-server/rygel-music-item.vala"
	result = self->priv->_track_number;
#line 38 "../src/librygel-server/rygel-music-item.vala"
	return result;
#line 629 "rygel-music-item.c"
}

void
rygel_music_item_set_track_number (RygelMusicItem* self,
                                   gint value)
{
	gint old_value;
#line 38 "../src/librygel-server/rygel-music-item.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/librygel-server/rygel-music-item.vala"
	old_value = rygel_music_item_get_track_number (self);
#line 38 "../src/librygel-server/rygel-music-item.vala"
	if (old_value != value) {
#line 38 "../src/librygel-server/rygel-music-item.vala"
		self->priv->_track_number = value;
#line 38 "../src/librygel-server/rygel-music-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_music_item_properties[RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY]);
#line 647 "rygel-music-item.c"
	}
}

RygelThumbnail*
rygel_music_item_get_album_art (RygelMusicItem* self)
{
	RygelThumbnail* result;
	RygelThumbnail* _tmp0_;
#line 40 "../src/librygel-server/rygel-music-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/librygel-server/rygel-music-item.vala"
	_tmp0_ = self->priv->_album_art;
#line 40 "../src/librygel-server/rygel-music-item.vala"
	result = _tmp0_;
#line 40 "../src/librygel-server/rygel-music-item.vala"
	return result;
#line 664 "rygel-music-item.c"
}

static gpointer
_rygel_icon_info_ref0 (gpointer self)
{
#line 40 "../src/librygel-server/rygel-music-item.vala"
	return self ? rygel_icon_info_ref (self) : NULL;
#line 672 "rygel-music-item.c"
}

void
rygel_music_item_set_album_art (RygelMusicItem* self,
                                RygelThumbnail* value)
{
	RygelThumbnail* old_value;
#line 40 "../src/librygel-server/rygel-music-item.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/librygel-server/rygel-music-item.vala"
	old_value = rygel_music_item_get_album_art (self);
#line 40 "../src/librygel-server/rygel-music-item.vala"
	if (old_value != value) {
#line 686 "rygel-music-item.c"
		RygelThumbnail* _tmp0_;
#line 40 "../src/librygel-server/rygel-music-item.vala"
		_tmp0_ = _rygel_icon_info_ref0 (value);
#line 40 "../src/librygel-server/rygel-music-item.vala"
		_rygel_icon_info_unref0 (self->priv->_album_art);
#line 40 "../src/librygel-server/rygel-music-item.vala"
		self->priv->_album_art = _tmp0_;
#line 40 "../src/librygel-server/rygel-music-item.vala"
		g_object_notify_by_pspec ((GObject *) self, rygel_music_item_properties[RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY]);
#line 696 "rygel-music-item.c"
	}
}

static void
rygel_music_item_class_init (RygelMusicItemClass * klass,
                             gpointer klass_data)
{
#line 35 "../src/librygel-server/rygel-music-item.vala"
	rygel_music_item_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/librygel-server/rygel-music-item.vala"
	g_type_class_adjust_private_offset (klass, &RygelMusicItem_private_offset);
#line 35 "../src/librygel-server/rygel-music-item.vala"
	((RygelMediaObjectClass *) klass)->compare_by_property = (gint (*) (RygelMediaObject*, RygelMediaObject*, const gchar*)) rygel_music_item_real_compare_by_property;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	((RygelMediaObjectClass *) klass)->apply_didl_lite = (void (*) (RygelMediaObject*, GUPnPDIDLLiteObject*)) rygel_music_item_real_apply_didl_lite;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	((RygelMediaObjectClass *) klass)->serialize = (GUPnPDIDLLiteObject* (*) (RygelMediaObject*, RygelSerializer*, RygelHTTPServer*, GError**)) rygel_music_item_real_serialize;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_music_item_get_property;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_music_item_set_property;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_music_item_finalize;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY, rygel_music_item_properties[RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY] = g_param_spec_int ("track-number", "track-number", "track-number", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/librygel-server/rygel-music-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY, rygel_music_item_properties[RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY] = rygel_param_spec_icon_info ("album-art", "album-art", "album-art", RYGEL_TYPE_THUMBNAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 724 "rygel-music-item.c"
}

static void
rygel_music_item_instance_init (RygelMusicItem * self,
                                gpointer klass)
{
#line 35 "../src/librygel-server/rygel-music-item.vala"
	self->priv = rygel_music_item_get_instance_private (self);
#line 38 "../src/librygel-server/rygel-music-item.vala"
	self->priv->_track_number = -1;
#line 735 "rygel-music-item.c"
}

static void
rygel_music_item_finalize (GObject * obj)
{
	RygelMusicItem * self;
#line 35 "../src/librygel-server/rygel-music-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_MUSIC_ITEM, RygelMusicItem);
#line 40 "../src/librygel-server/rygel-music-item.vala"
	_rygel_icon_info_unref0 (self->priv->_album_art);
#line 35 "../src/librygel-server/rygel-music-item.vala"
	G_OBJECT_CLASS (rygel_music_item_parent_class)->finalize (obj);
#line 748 "rygel-music-item.c"
}

/**
 * Represents a music item.
 */
 G_GNUC_NO_INLINE static GType
rygel_music_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelMusicItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_music_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMusicItem), 0, (GInstanceInitFunc) rygel_music_item_instance_init, NULL };
	GType rygel_music_item_type_id;
	rygel_music_item_type_id = g_type_register_static (RYGEL_TYPE_AUDIO_ITEM, "RygelMusicItem", &g_define_type_info, 0);
	RygelMusicItem_private_offset = g_type_add_instance_private (rygel_music_item_type_id, sizeof (RygelMusicItemPrivate));
	return rygel_music_item_type_id;
}

GType
rygel_music_item_get_type (void)
{
	static volatile gsize rygel_music_item_type_id__once = 0;
	if (g_once_init_enter (&rygel_music_item_type_id__once)) {
		GType rygel_music_item_type_id;
		rygel_music_item_type_id = rygel_music_item_get_type_once ();
		g_once_init_leave (&rygel_music_item_type_id__once, rygel_music_item_type_id);
	}
	return rygel_music_item_type_id__once;
}

static void
_vala_rygel_music_item_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	RygelMusicItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MUSIC_ITEM, RygelMusicItem);
#line 35 "../src/librygel-server/rygel-music-item.vala"
	switch (property_id) {
#line 35 "../src/librygel-server/rygel-music-item.vala"
		case RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		g_value_set_int (value, rygel_music_item_get_track_number (self));
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-music-item.vala"
		case RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		rygel_value_set_icon_info (value, rygel_music_item_get_album_art (self));
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 798 "rygel-music-item.c"
		default:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 804 "rygel-music-item.c"
	}
}

static void
_vala_rygel_music_item_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	RygelMusicItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_MUSIC_ITEM, RygelMusicItem);
#line 35 "../src/librygel-server/rygel-music-item.vala"
	switch (property_id) {
#line 35 "../src/librygel-server/rygel-music-item.vala"
		case RYGEL_MUSIC_ITEM_TRACK_NUMBER_PROPERTY:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		rygel_music_item_set_track_number (self, g_value_get_int (value));
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 35 "../src/librygel-server/rygel-music-item.vala"
		case RYGEL_MUSIC_ITEM_ALBUM_ART_PROPERTY:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		rygel_music_item_set_album_art (self, rygel_value_get_icon_info (value));
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 830 "rygel-music-item.c"
		default:
#line 35 "../src/librygel-server/rygel-music-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/librygel-server/rygel-music-item.vala"
		break;
#line 836 "rygel-music-item.c"
	}
}

